// **********************************************************************
//
// Copyright (c) 2003-2017 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.7.0
//
// <auto-generated>
//
// Generated from file `Metrics.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package IceMX;

/**
 * Provides information on servant dispatch.
 *
 **/
public class DispatchMetrics extends Metrics
{
    public DispatchMetrics()
    {
        super();
        this.userException = 0;
        this.size = 0L;
        this.replySize = 0L;
    }

    public DispatchMetrics(String id, long total, int current, long totalLifetime, int failures, int userException, long size, long replySize)
    {
        super(id, total, current, totalLifetime, failures);
        this.userException = userException;
        this.size = size;
        this.replySize = replySize;
    }

    private static class _F implements Ice.ValueFactory
    {
        public Ice.Object create(String type)
        {
            assert(type.equals(ice_staticId()));
            return new DispatchMetrics();
        }
    }
    private static Ice.ValueFactory _factory = new _F();

    public static Ice.ValueFactory
    ice_factory()
    {
        return _factory;
    }

    private static final String[] _ids =
    {
        "::Ice::Object",
        "::IceMX::DispatchMetrics",
        "::IceMX::Metrics"
    };

    public boolean ice_isA(String s)
    {
        return java.util.Arrays.binarySearch(_ids, s) >= 0;
    }

    public boolean ice_isA(String s, Ice.Current current)
    {
        return java.util.Arrays.binarySearch(_ids, s) >= 0;
    }

    public String[] ice_ids()
    {
        return _ids;
    }

    public String[] ice_ids(Ice.Current current)
    {
        return _ids;
    }

    public String ice_id()
    {
        return _ids[1];
    }

    public String ice_id(Ice.Current current)
    {
        return _ids[1];
    }

    public static String ice_staticId()
    {
        return _ids[1];
    }

    protected void _iceWriteImpl(Ice.OutputStream ostr_)
    {
        ostr_.startSlice(ice_staticId(), -1, false);
        ostr_.writeInt(userException);
        ostr_.writeLong(size);
        ostr_.writeLong(replySize);
        ostr_.endSlice();
        super._iceWriteImpl(ostr_);
    }

    protected void _iceReadImpl(Ice.InputStream istr_)
    {
        istr_.startSlice();
        userException = istr_.readInt();
        size = istr_.readLong();
        replySize = istr_.readLong();
        istr_.endSlice();
        super._iceReadImpl(istr_);
    }

    /**
     * The number of dispatch that failed with a user exception.
     *
     **/
    public int userException;

    /**
     * The size of the dispatch. This corresponds to the size of the
     * marshalled input parameters.
     *
     **/
    public long size;

    /**
     * The size of the dispatch reply. This corresponds to the size of
     * the marshalled output and return parameters.
     *
     **/
    public long replySize;

    public DispatchMetrics
    clone()
    {
        return (DispatchMetrics)super.clone();
    }

    public static final long serialVersionUID = 8536118955902550290L;
}
